# -*- coding: utf-8 -*-

# Copyright (C) 2017-2020 RhodeCode GmbH
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License, version 3
# (only), as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# This program is dual-licensed. If you wish to learn more about the
# RhodeCode Enterprise Edition, including its added features, Support services,
# and proprietary license terms, please see https://rhodecode.com/licenses/

from uuid import uuid4
from pyramid.decorator import reify
from pyramid.request import Request as _Request
from rhodecode.translation import _ as tsf


class Request(_Request):
    _req_id_bucket = list()

    @reify
    def req_id(self):
        return str(uuid4())

    @property
    def req_id_bucket(self):
        return self._req_id_bucket

    def req_id_records_init(self):
        self._req_id_bucket = list()

    def plularize(self, *args, **kwargs):
        return self.localizer.pluralize(*args, **kwargs)

    def translate(self, *args, **kwargs):
        localizer = self.localizer

        def auto_translate(*_args, **_kwargs):
            return localizer.translate(tsf(*_args, **_kwargs))

        return auto_translate(*args, **kwargs)
